#include<stdio.h>
#include<stdint.h>
#include "pke_parameters.h"
#include "indcpa_pke.h"
#include "randombytes.h"

int test_pke()
{
	uint16_t pk[PKE_N+PKE_UNIFORM_SEEDBYTES]; 
	uint16_t sk[PKE_N];
	uint8_t message[PKE_MESSAGEBYTES], message_decoded[PKE_MESSAGEBYTES];
	uint16_t ct[2*PKE_N];

	int COUNTER=0;
	
	printf("Testing PKE\n");

	while(COUNTER!=1000){
		randombytes(message, PKE_MESSAGEBYTES);

		indcpa_key_gen(pk, sk); 	
		indcpa_encryption(message, pk, ct);
		indcpa_decryption(sk, ct, message_decoded);

		for(int i=0; i<PKE_MESSAGEBYTES; i++)
			if(message[i] != message_decoded[i])
				printf("Error i=%d \t %x \t %x\n", i, message[i], message_decoded[i]);
		COUNTER++;
	}
	return 0;
}
